// Bernard Lidicky - 2005 - GPL - project Pexeso
package cz.nipax.hippo.pexeso;

import java.awt.Point;

/**
 * Implementation of "classic" inteligence with LHD and not enhanced random.
 * LHD = little hell deamon. After every turn it mixes the the pieces
 * that AI knows so AI is going to make a lot of mistakes.
 * This AI is cursed because of lhd :-)
 */

public class AI_lhd extends AI_forgetting {
		
	
	int m_type;
	
	/**
	 * Just a simple constructor
	 */
	public AI_lhd(Playground pg, int type){
		super(pg);
		m_type = type;
	}

	
	
	/**
	 * Get name of AI
	 * @return string with name
	 */
	public String getname(){
		return "Cursed AI";
	}
	
	/**
	 * Just removed random moves because it is done by LHD.
	 */
	protected boolean try_turn(int x, int y) {
		if (m_type == 1) little_hell_deamon();
		return m_pg.wantturn(this, x, y);
	}

	/**
	 * Cursing the AI :-)
	 */
	 public void onturn() {
		// NOOOOOO
		// little_hell_deamon();
		super.onturn();
	 }
	
	 /**
	  * Respond to revealed and cursing the AI.
	  */
	 public void revealed(int x, int y, int ID) {
		 if (m_type == 0) little_hell_deamon();
		 super.revealed(x,y,ID);
	 }
	 
	/**
	 * Randomly mixes knowlages of AI. 
	 */
	protected void little_hell_deamon() {
		
		if (m_pg.isEnd() || m_killed) return;
		
		// some random position
		int x, y;
		do {
			if (m_pg.isEnd() || m_killed) return;
			x = (int)(Math.random() * (double)m_x);
			y = (int)(Math.random() * (double)m_y);
		} while (m_field[x][y].valid == false);

		if (switchpieces(x,y,x+1,y) || switchpieces(x,y,x,y+1) ||
		    switchpieces(x,y,x-1,y) || switchpieces(x,y,x,y-1) ||
		    switchpieces(x,y,x+1,y+1) || switchpieces(x,y,x-1,y+1) ||
		    switchpieces(x,y,x+1,y-1) || switchpieces(x,y,x-1,y-1)) {
			println("Little hell deamon cursed the AI");
		}
				
		
	}
	
	/**
	 * Switches pieces in {@link #m_field}.
	 * @param x coordinate of first piece
	 * @param y coordinate of first piece
	 * @param a coordinate of second piece
	 * @param b coordinate of second piece
	 * @return true if switch was successfull
	 */
	protected boolean switchpieces(int x, int y, int a, int b) {
		// out of field
		if ( x < 0 || y < 0 || a < 0 || b < 0 ||
		     x >= m_x || y >= m_y || a >= m_x || b >= m_y) return false;
		
		// invalid pieces
		if (!m_field[x][y].valid || !m_field[a][b].valid) return false;

		// do the switch - doesn't switch other parameters since they are
		// important only for AI_forgetting
		int id = m_field[x][y].id;
		 m_field[x][y].id =  m_field[a][b].id;
		 m_field[a][b].id = id;

		 return true;
	}
}

	
