// Bernard Lidicky - 2005 - GPL - project Pexeso
package cz.nipax.hippo.pexeso;

/**
 * Implementation of totally stupid AI.
 * Overturns two random pieces when {@link #onturn}
 * is called. It doesn't remember which pieces are valid and calls
 * {@link Playground#wantturn} until true is returner two times.
 */
public class AI_random extends AI {
	
	/**
	 * Simple constructor - just calls <code>super</code>
	 */
	public AI_random(Playground pg){
		super(pg);
	}
		
	
	/**
	 * Get name of AI
	 * @return string with name
	 */
	public String getname(){
		return "Random AI";
	}

	/**
	 * Makes two random moves.
	 */
	public void onturn() {
		for (int t = 0; t < 2; t++)
			random_move();
	}

	/**
	 * Creates one valid random move. Valid means that 
	 * {@link Playground#wantturn} returns true.
	 */
	protected void random_move() {

		int x = (int)(Math.random() * (double)m_pg.getX());
		int y = (int)(Math.random() * (double)m_pg.getY());
		
		while (!m_pg.wantturn(this, x, y) && !m_killed && !m_pg.isEnd()) {
			x = (int)(Math.random() * (double)m_pg.getX());
			y = (int)(Math.random() * (double)m_pg.getY());
		}
	
	}
}
