// Bernard Lidicky - 2005 - GPL - project Pexeso
package cz.nipax.hippo.pexeso;
/*
 * For better theme support in pexeso :-)
 * */

import java.awt.*;

/**
 * This class should hold description of visualisation. It holds
 * images of cards, how lagre they are, spacing,...
 * TODO: Loadtable themes from a file would be a nice feature.
 */
public class PGTheme  {

	private Image m_image[];
	
	public PGTheme(){

		m_image = new Image[16];
		
		for (int i = 0; i < 16; i++) {
			String filename = "home"+i+".png";
			m_image[i] = loadImage(filename);
			if (m_image[i] == null) {
				System.err.println("Image: Unable to load "+filename);
			}
			// System.out.println("Image: "+filename+" loaded");
		}
	}

	/**
	 * Gets width of pisture.
	 * @return width of pictures
	 */
	public int getW() {
		return 80;
	}

	/**
	 * Gets width of pisture.
	 * @return height of pictures
	 */
	public int getH() {
		return 80;
	}
	
	/**
	 * Gets spacing between pictures when drawn in
	 * grid on the screen.
	 * @return space between pictures
	 */
	public int getSpace() {
		return 5;
	}

	/**
	 * Return <code>Image</code> associated with ID. Or null if no such
	 * an ID is valid. Negative ID is allways invalid.
	 * @param ID the ID of wanted image
	 * @return image of ID
	 */
	public Image getImage(int ID) {
		if (ID >= 16 || ID < 0) return null;
		return m_image[ID];
	}


	/**
	* Helper method to load an image file from the CLASSPATH or current dir
	* @param imageName the package and name of the file to load relative to the CLASSPATH or curent dir
	* @return an Image instance with the specified image file
	*/
	public Image loadImage( String imageName ) {
		Toolkit toolkit = Toolkit.getDefaultToolkit();
		Image i;
		ClassLoader classloader = getClass().getClassLoader();

		java.net.URL url = classloader.getResource( "images/" + imageName );
		if ( url != null )  {
			i = toolkit.getImage(url);
			if (i != null) return i;
		}

		 i = toolkit.getImage(imageName);
		 if (i != null) return i;

		 i = toolkit.getImage("images/"+imageName);
		 if (i != null) return i;
	 
		 System.out.println("ERROR - "+imageName+" not found.");
	 
		 return null;
	}
}
